/*
 * Perusserveri, joka vastaa pyyntöön 'Hello World' -tekstillä tai HTML-dokumentilla
 *
 * Ajetaan komentokehotteessa komennolla node basicserver
 * Sammutetaan komentokehotteessa CTRL-C:llä
 * Näkyy osoitteessa http://localhost:4000
 *
 */
const http = require('http');
/* createServer-metodi saa argumentikseen callback-funktion jonka argumentteina
   tulevat käyttöön 1) req eli request, joka on pyyntö eli serverille sisään tuleva tieto
   ja 2) response eli res, joka on vastaus eli serverin ulos vastauksena lähettämä tieto.
   Pyyntö eli req ei ole tässä käytössä, eli serverille ei tule sisään mitään dataa, vaan
   se pelkästään lähettää sitä ulos.
*/
const server = http.createServer((req, res) => {
  /*
    //header on tieto joka annetaan selaimelle siitä, minkä tyyppistä dataa serveriltä on tulossa.
    //headerit voisi laittaa näin niin on varmasti text -muotoa
    var body = 'Hello World';
    // kaikki tieto lähtee ulos responsessa eli res-oliossa
    res.setHeader('Content-Length', body.length);
    res.setHeader('Content-Type', 'text/plain');
    res.end(body);
    */

  //Tai tämmöiset headerit kun lähetetään HTML:ää
  const url = 'http://google.com';
  const body =
    '<p>Siirry osoitteeseen <a href="' + url + '">' + url + '</a></p>';
  // res.setHeader('Location', url); // Redirectointi eli suora ohjaus osoitteeseen
  // headerit lähetetään responsessa
  res.setHeader('Content-Length', body.length);
  res.setHeader('Content-Type', 'text/html');
  // res.statusCode = 302;
  res.end(body); // Kun vastaus on saatu, eli se loppuu (res.end), esitetään body selaimessa

  // Ei mitään headereita.
  // res.end('Hello World'); // Kommentoi yllä olevat jutut ja avaa tämä niin respose on 'Hello World'
});
server.listen(4000);
console.log('Serveri portissa 4000 tarjoaa responsen eli vastauksen');
