/*
Kävijälaskuri joka tallentaa tekstitiedostoon sivun reffaukset
luodaan serveri ja käsitellään tiedostoa. Ei tarvita muita
moduuleja kuin Noden coren sisältämät http ja fs
*/

const http = require('http'),
  fs = require('fs');

// Serverin luonti. Pyyntö ja vastaus ovat callbackin parametreina.
http
  .createServer((req, res) => {
    // Katsotaan pyytääkö käyttäjä juurikansiota /
    // käyttäjä reffaa selaimen eli hakee sivun http://localhost:3030/
    if (req.url == '/') {
      // tiedoston luku. laskuri.txt:ssä oleva data saadaan callbackin parametrista
      fs.readFile('laskuri.txt', 'utf-8', (err, data) => {
        if (err) { // lukuvirhe
          return console.log(err);
        }
        // http headeri
        res.writeHead(200, {
          'Content-Type': 'text/plain',
        });
        // jos laskuri.txt ei sisällä laskurin alkunumeroa, laitetaan 0
        if (!data) {
          data = 0;
        }
        // kasvatetaan dataa yhdellä
        data = parseInt(data) + 1;
        // kirjoitetaan tiedostoon
        fs.writeFile('laskuri.txt', String(data), (err) => {
          if (err) { // kirjoitusvirhe
            return console.log(err);
          }
          // response on vastaus palvelimelta
          res.end('This page was refreshed ' + data + ' times!');
        });      
      });
      // jos käyttäjä ei pyydä juurikansiota niin ei löydy mitään eli 404
    } else {
      res.writeHead(404);
      res.end();
    }
    // Serveri portissa 3030
  })
  .listen(3030);
console.log('Serveri toimii portissa 3030');
